/*
		Author:		T. Richner
		Date:		06.01.2010
		Project:	Demo for K8055 

		Description:
		 Shows how to program the K8055 Board with Visual C++
		
		Info:
		-dont forget to connect first!
		-loosely based on J. Schyma's K8055_C.h , thanks to him

		ToDo:
		-SetAnalog
		-Set/Clear Digital instead of toggle
		
*/

#include "stdafx.h"

#include <iostream>
#include "K8055_C.h"
#include <tchar.h>
#include <string>

using namespace std;


int _tmain(int argc, _TCHAR* argv[])
{
	long device = -1;
	bool port[8];

	for(int i=0; i<8;i++)
		port[i] = false;

	cout << "K8055 DEMO\t   by T. Richner\n";
	cout << "use 'help' for more info" << endl << endl;

	string cmd; //temp command

		do{
			cout << "\n[CMD]: ";
			cin >> cmd;
			if(cmd=="set"){
				int nbr;
				cout << "  $port: ";
				cin >> nbr;
				nbr--;
				if(nbr>=0&&nbr<8){
					port[nbr] = !port[nbr];	//toggles the specified Port-mode
					if(port[nbr]==true)
						SetDigitalChannel(nbr+1);//Turns the specified Port on
					if(port[nbr]==false)
						ClearDigitalChannel(nbr+1);//Turns the specified Port off
				}
			}else if(cmd=="connect"){
				cout << "  $adress: ";
				cin >> device;
				long h = OpenDevice(device);
				switch (h) {
					case  0 :
					case  1 :
					case  2 :
					case  3 :
						cout << "Card " << h << " connected";
						break;
					case  -1 :
						cout << "Card " << device << " not found";
				}
				cout << endl;
			}else if(cmd=="read"){
				cout << endl << endl
					<< "\t ANALOG Inputs" << endl
					<< "\t-------------------" << endl;
				long an1;
				long an2;
				ReadAllAnalog(&an1, &an2);
				cout << "\n\tAnalog 1: " << an1 ;
				cout << "\n\tAnalog 2: " << an2 ;

				cout << endl << endl
					<< "\t DIGITAL Inputs" << endl
					<< "\t-------------------" << endl;
				long digi;
				digi = ReadAllDigital();
				int n=1;
				for(int i=1;i<32;i=i*2){
					cout << "\n\tInput " << n << " : ";
					cout << (((digi) & (i))>0);
					n++;
				}

				cout << endl;
			}else if(cmd=="help"){
				//Commands:
				cout << endl
					<< "\tCOMMANDS:" << endl
					<< "\tset"	<< endl
					<< "\tread"	<< endl
					<< "\tquit"	<< endl
					<< "\thelp"	<< endl
					<< "\tconnect" << endl
					<< "\ttest"	<< endl;
			}else if(cmd=="test"){ //tests all digital outputs several times
				cout << "testing... ";
				unsigned int n=0;
				while(n<160){
					port[n%8]=false;
					ClearDigitalChannel(n%8+1);
					n++;
					port[n%8] = true;
					SetDigitalChannel(n%8+1);
					Sleep(50);
					if(n%4)
						cout << "\b \b";
					else
						cout << ".. ";
				}
				ClearDigitalChannel(n%8+1);
				cout << "\rtesting... finished" << endl;
			}
			
		}while(cmd!="quit");

	ClearAllDigital();
	CloseDevice();
	return 0;
}
